characterselect:
	xor a
	ld (curround), a
	call clearscreen
	ld hl, scharstring
	ld de, $0010
	call drawstring
cselectloop:
	call clearselection
	ld a, (cselector)
	ld de, CHAR1DATA-$8000
	call getcharvar
	ld hl, CHAR1DATA
	ld de, $060f
	call drawspr2416
dstuff:
	ld hl, leftarrow
	ld de, $2001
	call drawstring
	ld hl, rightarrow
	ld de, $2017
	call drawstring
	ld a, (cselector)
	ld de, $1840
	call drawcharname
	ld hl, namestring
	ld de, $182a
	call drawstring
	ld a, (charstatsshow)
	or a
	jr z, pcharkeyloop
	ld a, (cselector)
	ld l, a
	ld h, 0
	ld de, speedtable
	add hl, de
	push hl
	ld a, (hl)
	ld hl, $fe93
	call drawbar
	pop hl
	ld de, 17
	add hl, de
	ld a, (hl)
	ld hl, $ff13
	call drawbar
	ld hl, speedstring
	ld de, $2701
	call drawstring
	ld hl, powerstring
	ld de, $2f01
	call drawstring
pcharkeyloop:
	ld hl, counter
	inc (hl)
	ld a, (hl)
	and %01111111
	jp z, changestance
	ld a, 8
	call hline
	ld a, $39
	call hline
	ld b, 5
	call keyloop
	or a
	jr z, pcharkeyloop
	push af
	call waitkey
	pop af
	ld b, a
	and %01000000
	call nz, chargoleft
	ld a, b
	and %00100000
	call nz, chargoright
	ld a, b
	and %00000100
	jp z, cselectloop
	ld a, (cselector)
	ret
chargoleft:
	ld a, (cselector)
	ld hl, availablechars
	ld e, a
	ld d, 0
	add hl, de
doleftagian:
	dec e
	ld a, e
	cp 255
	call z, settotopchars
	dec hl
	ld a, (hl)
	or a
	jr z, doleftagian
	ld a, e
	ld (cselector), a
	ret
settotopchars:
	ld e, NUM_CHARS-1
	ld hl, availablechars+NUM_CHARS
	ret
chargoright:
	ld a, (cselector)
	ld hl, availablechars
	ld e, a
	ld d, 0
	add hl, de
dorightagian:
	inc e
	ld a, e
	cp NUM_CHARS
	call z, settobottomchars
	inc hl
	ld a, (hl)
	or a
	jr z, dorightagian
	ld a, e
	ld (cselector), a
	ret
settobottomchars:
	ld e, 0
	ld hl, availablechars-1
	ret

drawbar:
	push hl
	push hl
	ld de, $3200
	or a
	sbc hl, de
	pop de
	srl a
	srl a
	ld b, a
	ld c, %00001000
dbarloop:
	ld a, (de)
	or c
	ld (de), a
	rrc c
	ld a, (de)
	or c
	ld (de), a
	ld a, (hl)
	or c
	ld (hl), a
	rrc c
	ld a, (de)
	or c
	ld (de), a
	rrc c
	ld a, (hl)
	or c
	ld (hl), a
	rrc c
	jr nc, dbarloop2
	inc hl
	inc de
dbarloop2
	djnz dbarloop
	pop hl
	push hl
	ld de, 16
	add hl, de
	ex de, hl
	pop hl
	push hl
	ld bc, 16
	ldir
	pop hl
	push hl
	ld de, 32
	add hl, de
	ex de, hl
	pop hl
	ld bc, 16
	ldir
	ret
	
scharstring
	.text "Select your fighter!"
rightarrow:
	.db 5, 0
leftarrow:
	.db 207, 0
cselector:
	.db 0
cselpos:
	.dw 0
namestring:
	.text "Name:"
speedstring
	.text "Speed:"
powerstring:
	.text "Power:"

changestance:
	call clearselection
	ld de, $060f
	ld hl, curround
	ld a, (hl)
	xor 1
	ld (hl), a
	or a
	jr z, drawreg
	ld hl, CHAR1DATA+96
finishstance
	call drawspr2416
	jp dstuff
drawreg
	ld hl, CHAR1DATA
	jr finishstance

speedtable:
	.db 70, 55, 60, 50, 90, 75, 60, 60, 45, 60, 50
	.db 80, 55, 55, 50, 50, 30
powertable:
	.db 52, 44, 48, 56, 40, 64, 52, 56, 52, 60, 40
	.db 28, 48, 52, 48, 52, 80
.end
